// 要素 ----------
var $window = $(window);
var $doc = $(document);
var $header = $('#header');
var $global_nav = $('#global-nav');
var $main_header = $('#main-header');
var $user_info = $('#user-info');
var $operation = $('#operation');
var $footer = $('#footer');
var $check_all = $('input[type="checkbox"][data-role="check-all"]');
var $jump_content = $('[data-role="jump-content"]');
var $sub_nav = $('#sub-nav');
var $btn_sp_global_nav = $('#btn-sp-global-nav');
var $btn_sp_user_info = $('#btn-sp-user-info');
var $overlay = $('.overlay');


//
var timer = false;

// イベント登録 ----------
$window.on('load scroll resize', setOperationPosition);
$window.on('resize', resizeReset); //20220131 レスポンシブ時の挙動を外す
$window.on('resize', resetOverlayItems);
if (isSP()) {
    resetOverlaySubNav();
}

$window.on('resize load', setGlobalNavEvent);
$check_all.on('change', checkAll);

$('.global-nav-child span').on('click', selectGlobalNaviChild);
$('[data-role="global-nav-back"]').on('click', backGlobalNaviChild);

$btn_sp_user_info.on('click', showSPUserInfo);
$btn_sp_global_nav.on('click', showSPGlobalNav);
$overlay.on('click', resetOverlayItems);

$('.frm-select > select').on('change', setSelectClass);
$('.frm-text').on('change', setTextClass);
$('.frm-date > input').on('change', setDateClass);
$('.btn-error-expand').on('click', expandError);
$('a[href^="#"]').on('click', jumpPageLink);
$('[data-role="sub-nav-expand"]').on('click', expandSubNav);
$('.mmenu-title').on('click', expandTopMegaMenu); //20220131 レスポンシブ時の挙動を外す

$('input[type="text"]:required').on('blur', validateCheck);

// table ページネーション
$window.on('load', initPaginationTable);

// table 1行ずつ表示
$window.on('load', initMoreTableRow);

// 別表 1つずつ表示
$window.on('load', initMoreOtherItem);

// ナビ固定
$window.on('load scroll resize', resizeSubnav);

// ツールチップ表示
$('.tool-tip-icon').on('click', showTooltip);

// ツールチップ以外の箇所クリックでツールチップ非表示
$(document).on('click', function (e) {
    if (!$(e.target).hasClass('tool-tip-icon')) {
        $('.tool-tip-wrap').removeClass('show').children('.tool-tip').css({left: ''});
    }
});

// サブメニューのチェックと連動
$('[id^="check"]').on('click', relatedSubnavCheck);

// カレンダー（flatpickr）
if ($('.Calender').length > 0) {

    $('.Calender').flatpickr({
        'locale': 'ja',
        'dateFormat': "Ymd",
        'allowInput': true,
        'disableMobile': 'true',
        onDayCreate: function (dObj, dStr, fp, dayElem) {
            // 土日クラス付与
            var dow = dayElem.dateObj.getDay();
            switch (dow) {
                case 0: $(dayElem).addClass('sunday'); break;
                case 6: $(dayElem).addClass('saturday'); break;
            }
            // 祝日クラス付与
            var Y = dayElem.dateObj.getFullYear();
            var M = dayElem.dateObj.getMonth() + 1;
            var D = dayElem.dateObj.getDate();
            var ymd = [Y, ('0' + M).slice(-2), ('0' + D).slice(-2)].join('-');
            if (ymd in holidays) $(dayElem).addClass('holiday');
        }
    });
}

// 1件もチェックされていない時
$('[data-role="check-limit-btn"]').on('click', noChecked);

// チェック数制限
$('[data-role="check-limit-table"] tbody [type="checkbox"]').on('change', checkLimit);

// 領域外クリックで項目を非表示に_global-nav-child
$doc.on('click', function (e) {
    if (($(e.target).closest('.global-nav-child').length == 0) && !$(e.target).is('[data-role="show-global-nav-child"]')) {
        $('.global-nav-child').removeClass('show');
    }
});

// ロード時アンカーにジャンプ
$window.on('load', jumpAnchorByLoad);

// 縦スクロールの有無でジャンプボタンの表示非表示
$window.on('load resize', showPagejumpNav);

// ジャンプするコンテンツの数で↑↓ボタンを表示非表示
$window.on('load', setPagejumpNav);


// function ----------

/**
 * 
 */
function setGlobalNavEvent() {
    $global_nav.find('> ul > li > [data-role="show-global-nav-child"]').off('click', showGlobalMenuChild).on('click', showGlobalMenuChild);
}

/**
 * メガメニュー表示
 */
function showGlobalMenuChild(e) {
    console.log('showGlobalMenuChild');
    var $current;
    $current = $(e.currentTarget).closest('li');
    //console.log($current);
    if (isSP()) {
        $current.find('.global-nav-child').addClass('show').closest('li').siblings('li').find('.global-nav-child').removeClass('show');
    } else {
        if ($current.find('.global-nav-child').hasClass('show')) {
            $current.find('.global-nav-child').removeClass('show');
        } else {
            $current.find('.global-nav-child').addClass('show').closest('li').siblings('li').find('.global-nav-child').removeClass('show');
        }
    }
}

/**
 * メガメニュー非表示
 */
function hideGlobalMenuChild(e) {
    //console.log('hideGlobalMenuChild');
    var $current = $(e.currentTarget);
    $current.find('.global-nav-child').removeClass('show');
    $current.find('.selected').removeClass('selected');
    //$('.overlay').removeClass('show');
}

/**
 * メガメニュー内の項目選択
 */
function selectGlobalNaviChild(e) {
    var $current = $(e.currentTarget);
    //var $wrap = $current.closest('ul');
    //$wrap.children('li').children('.selected').removeClass('selected');
    var $wrap = $current.closest('ul');
    //console.log('[selectGlobalNaviChild]', $current);
    $wrap.children('li').children('.selected').removeClass('selected');
    $current.addClass('selected');
    return false;
}

/**
 * メガメニュー内のもどる
 */
function backGlobalNaviChild(e) {
    var $current = $(e.currentTarget);
    var $target;
    if ($current.parent().parent().hasClass('global-nav-grandchild')) {
        $target = $current.closest('.global-nav-grandchild').prev();
        $target.removeClass('selected');
        //console.log('2階層');
    } else {
        $target = $current.closest('.global-nav-child');
        $target.removeClass('show');
        //console.log('1階層');
    }
}

/**
 * SP時ユーザー情報表示
 */
function showSPUserInfo(e) {
    var $current = $(e.currentTarget);
    var target_id = $current.data('target');
    var $target = $(target_id);
    var show_icon = $current.data('showIcon');
    var hide_icon = $current.data('hideIcon');
    resetOverlayGlobalNav();
    resetOverlaySubNav();
    if ($target.hasClass('show')) {
        $target.removeClass('show');
        $current.children('.material-icons').text(show_icon);
        $('.overlay').removeClass('show');
    } else {
        $target.addClass('show');
        $current.children('.material-icons').text(hide_icon);
        $('.overlay').addClass('show');
    }
}

/**
 * SP時グローバルメニュー表示
 */
function showSPGlobalNav(e) {
    var $current = $(e.currentTarget);
    var target_id = $current.data('target');
    var $target = $(target_id);
    var show_icon = $current.data('showIcon');
    var hide_icon = $current.data('hideIcon');
    resetOverlayUserInfo();
    resetOverlaySubNav();
    if ($target.hasClass('show')) {
        $target.removeClass('show');
        $current.children('.material-icons').text(show_icon);
        $('.overlay').removeClass('show');
    } else {
        $target.addClass('show');
        $current.children('.material-icons').text(hide_icon);
        $('.overlay').addClass('show');
    }
}

/**
 * 
 */
function resetOverlayItems() {
    //console.log('[resetOverrayItems]');
    resetOverlayUserInfo();
    resetOverlayGlobalNav();
    if (isSP()) {
        resetOverlaySubNav();
    }
    $overlay.removeClass('show');
}
function resetOverlayUserInfo() {
    //console.log('[resetOverrayUserInfo]');
    $user_info.removeClass('show');
    $btn_sp_user_info.children('.material-icons').text($btn_sp_user_info.data('showIcon'));
    $overlay.removeClass('show');
}
function resetOverlayGlobalNav() {
    //console.log('[resetOverrayGlobalNav]');
    $main_header.removeClass('show').find('.global-nav-child.show').removeClass('show').find('span.selected').removeClass('selected');
    $btn_sp_global_nav.children('.material-icons').text($btn_sp_global_nav.data('showIcon'));
    $overlay.removeClass('show');
}
function resetOverlaySubNav() {
    //console.log('[resetOverraySubNav]');
    $sub_nav.addClass('hide');
    $overlay.removeClass('show');
}



/**
 * ページ最下部にスクロール時、フローティングエリアをずらしてフッターを表示する
 */
function setOperationPosition() {
    if (!isSP()) {
        if ($operation.length > 0) {
            var win_height = $window.outerHeight();
            var win_scroll_top = $window.scrollTop();
            var doc_height = $doc.outerHeight();
            var footer_height = $footer.outerHeight();
            var page_bottom = (doc_height - win_height);
            if (page_bottom <= win_scroll_top) {
                $operation.css({ bottom: Math.floor(footer_height) });
            } else {
                $operation.css({ bottom: 0 });
            }
					
					
						// ページ内リンクボタンの表示・非表示（2022/4追加）//
						//console.log('[win_height]', win_height);
						//console.log('[doc_height]', doc_height);
						/*if (doc_height <= win_height) {
								//console.log('[page_jump:hide]');
								$("#page_jump").fadeOut(400);
						} else {
								//console.log('[page_jump:show]');
								$("#page_jump").fadeIn(400);
						}*/
        }
    }
}



/**
 * エラーインフォメーションの伸縮
 * @param {event} e 
 */
function expandError(e) {
    var $current = $(e.currentTarget);
    var $wrap = $current.closest('.error-wrap');
    var $content = $wrap.find('.error-content');
    var close_icon = $current.data('closeIcon');
    var close_text = $current.data('closeText');
    var open_icon = $current.data('openIcon');
    var open_text = $current.data('openText');
    var current_height = $content.height();
    var expand_height = $content.css('height', 'auto').height();
    if ($wrap.hasClass('shrink')) {
        $current.find('.error-btn-label').text(close_text);
        $current.find('.error-icon').text(close_icon);
        $content.height(current_height).animate({ height: expand_height }, 'fast', function () {
            $wrap.removeClass('shrink');
        });
    } else {
        $current.find('.error-btn-label').text(open_text);
        $current.find('.error-icon').text(open_icon);
        $wrap.addClass('shrink');
        $content.animate({ height: 50 }, 'fast');
    }
}



/**
 * セレクト選択時の動作
 * @param {event} e 
 */
function setSelectClass(e) {
    var $current = $(e.currentTarget);
    var $wrap = $current.closest('.frm-select');
    if ($(e.currentTarget).prop('selectedIndex') > 0) {
        $wrap.removeClass('frm-empty');
    } else {
        $wrap.addClass('frm-empty');
    }
}

/**
 * テキスト入力時の動作
 * @param {event} e 
 */
function setTextClass(e) {
    var $current = $(e.currentTarget);
    if ($current.val() !== '') {
        $current.removeClass('frm-empty');
    } else {
        $current.addClass('frm-empty');
    }
}

/**
 * 日付入力時の動作
 * @param {event} e 
 */
function setDateClass(e) {
    var $current = $(e.currentTarget);
    var $wrap = $current.closest('.frm-date');
    if ($current.val() !== '') {
        $wrap.removeClass('frm-empty');
    } else {
        $wrap.addClass('frm-empty');
    }
}



/**
 * 全チェック、全解除
 * @param {*} e 
 */
function checkAll(e) {
    var $current = $(e.currentTarget);
    var target_id = $current.data('checkTarget');
    var $target = $(target_id);
    var $checkboxes = $target.find('.frm-checkbox > input[type="checkbox"]');
    var $btns_check_all = $('[data-role="check-all"][data-check-target="' + target_id + '"]');
    if ($current.prop('checked')) {
        $checkboxes.prop('checked', true);
        $btns_check_all.prop('checked', true);
        //20211109 検討会用追加
        $('[id^="edit"]').addClass('show');
    } else {
        $checkboxes.prop('checked', false);
        $btns_check_all.prop('checked', false);
        //20211109 検討会用追加
        $('[id^="edit"]').removeClass('show');
    }
}

/**
 * サブメニューのチェックと連動
 * @param {*} e 
 */
function relatedSubnavCheck(e) {
    var $current = $(e.currentTarget);
    var current_id = $current.attr('id').substr(5, 4);
    var target_id = "#edit" + current_id;
    if ($(this).prop('checked')) {
        $(target_id).addClass('show');
    } else {
        $(target_id).removeClass('show');
    }

}



/**
 * ページ内リンク スムーススクロール
 * @param {event} e 
 * @returns 
 */
function jumpPageLink(e) {
    var doc_height = $doc.outerHeight();
    var $current = $(e.currentTarget);
    var header_height = ($header.height());
    var target_id = $current.attr('href');
    var pos = 0;
    var $target;
    var current_jump_idx;
		var scroll_flg = true;
    if (target_id !== '#') {
        current_jump_idx = getCurrentJumpContetntIdx()[0];
        var pos_flg = getCurrentJumpContetntIdx()[1];
        $target = $(target_id);
        pos = 0;
        if (target_id === '#pagetop') {
            // ページトップへ
            pos = 0;
        } else if (target_id === '#pagebottom') {
            // ページ最下部へ
            pos = doc_height;
        } else if (target_id === '#content_prev') {
            // 1つ前の項目へ
            if (current_jump_idx == undefined) {
                pos = $window.scrollTop();
            } else {
                if (current_jump_idx !== 0 && pos_flg == true) {
                    current_jump_idx--;
                }
                pos = $jump_content.eq(current_jump_idx).offset().top - header_height;
            }
        } else if (target_id === '#content_next') {
            // 1つ次の項目へ
            if (current_jump_idx == undefined) {
                current_jump_idx = 0;
								pos = $jump_content.eq(current_jump_idx).offset().top - header_height;
            } else {
                if (current_jump_idx < ($jump_content.length-1)) {
                  //if (pos_flg) {
                    current_jump_idx++;
                  //}
                } else if (current_jump_idx == ($jump_content.length-1)) {
                  if (pos_flg == false) {
                    scroll_flg = false;
                  }
                }
                pos = $jump_content.eq(current_jump_idx).offset().top - header_height;
              
                /*if (current_jump_idx < ($jump_content.length-1) && pos_flg == true) {
                    current_jump_idx++;
										pos = $jump_content.eq(current_jump_idx).offset().top - header_height;
								} else {
										scroll_flg = false;
								}*/
            }
        } else {
            if ($target.length > 0) {
                pos = $target.offset().top - header_height;
                history.pushState(null, null, target_id);
            }
        }
			
				if (scroll_flg) {
						$('html, body').animate({
								scrollTop: pos
						}, 400, 'swing');
				}
    }
    return false;
}


/**
 * TODO ページ内リンク「前へ」「次へ」インデックス設定
 */
function getCurrentJumpContetntIdx(type) {
    //var $jump_content = $('[data-role="jump-content"]');
    var hit_idx;
    var doc_height = $doc.outerHeight();
    var win_height = $window.outerHeight();
    var win_scroll_top = $window.scrollTop();
    var header_height = $header.outerHeight();
    var flg = false;
    $jump_content.each(function (i, o) {
        var start, end;
        var current_jump_pos = Math.floor($(o).offset().top - header_height);
        if (i === 0) {
            start = current_jump_pos;
						if ($jump_content.length == 1) {
								end = doc_height;
						} else {
            		end = Math.floor($jump_content.eq(i + 1).offset().top - header_height);
						}
            //console.log('[最初]', start, end);
            if (0 <= win_scroll_top && win_scroll_top < start) {
                hit_idx = undefined;
                return false;
            } else {
                if (start <= win_scroll_top && win_scroll_top < end) {
                    if (start == win_scroll_top) {
                        flg = true;
                    } else {
                        flg = false;
                    }
                    hit_idx = i;
                    return false;
                }
            }
        } else if (i === ($jump_content.length - 1)) {
            // 最後
            start = current_jump_pos;
            end = doc_height;
            //console.log('[最後]', start, end);
            if (start <= win_scroll_top && win_scroll_top < end) {
								if (start == win_scroll_top) {
                    flg = true;
                } else {
                    flg = false;
                }
							
                hit_idx = i;
                return false;
            }
        } else {
            // 中間
            start = current_jump_pos;
            end = Math.floor($jump_content.eq(i + 1).offset().top - header_height);
            //console.log('[中間]', start, end);
            if (start <= win_scroll_top && win_scroll_top < end) {
                //console.log('[i]', i);
                //console.log('[中間]', start, end);
                //console.log('[win_scroll_top]', win_scroll_top);
                if (start == win_scroll_top) {
                    flg = true;
                } else {
                    flg = false;
                }
              
                hit_idx = i;
                return false;
            }
        }
    });
    //console.log('[hit_idx]', hit_idx);
    //console.log('[pos_flg]', flg);
    return [hit_idx, flg];
}

/**
 * サブナビ表示非表示
 */
function expandSubNav(e) {
    var $current = $(e.currentTarget);
    if ($sub_nav.hasClass('hide')) {
        $sub_nav.removeClass('hide');
        $overlay.addClass('show');
    } else {
        $sub_nav.addClass('hide');
        $overlay.removeClass('show');
    }
    if (!isSP()) {
        $overlay.removeClass('show');
    }

}


/**
 * スマホ時トップのメガメニュー開閉
 * @param {event} e 
 */
function expandTopMegaMenu(e) {
    if (isSP()) {
        var $current = $(e.currentTarget);
        var $target = $current.next();
        //console.log($target.is(':visible'));
        $target.slideToggle(function () {
            if ($target.is(':visible')) {
                $current.removeClass('hide');
                $target.removeClass('hide');
            } else {
                $current.addClass('hide');
                $target.addClass('hide');
            }
        });
    }
}


/**
 * SP/PC切り替わり時にメニューの表示状態などをリセットする
 * @param {event} e 
 */
function resizeReset(e) {
    var $mmenu_title = $('.mmenu-title');
    $mmenu_title.each(function (i, o) {
        var $mmenu_list = $(o).next();
        if ($mmenu_list.hasClass('hide')) {
            // トップのメガメニュー
            if (isSP()) {
                $mmenu_list.hide();
            } else {
                $mmenu_list.show();
            }
        }

    });
    // サイドナビ
    if (isSP()) {
        if (!$sub_nav.hasClass('hide')) {
            $sub_nav.addClass('hide');
        }
    } else {
    }
}

/**
 * バリデートチェック
 */
function validateCheck(e) {
    var $current = $(e.currentTarget);
    var str_input = $current.val();
    var pattern = $current.attr('pattern');
    var reg = new RegExp(pattern, 'i');
    var str_validate_error = $current.data('validateError');
    var $validate_error = '<p class="validate-error">' + str_validate_error + '</p>';
    if (str_input.search(reg) == -1) {
        $current.removeClass('frm-error').closest('td').find('.validate-error').remove();
        $current.addClass('frm-error').closest('td').append($validate_error);
    } else {
        $current.removeClass('frm-error').closest('td').find('.validate-error').remove();
    }
}

/**
 * SP判定（幅のみで判定）
 */
function isSP() {
    var result = false;
    var pc_width = 1023;
    if ($window.outerWidth() <= pc_width) {
        result = true;
    }
    return result;
}


/**
 * ツールチップ表示
 * @param {*} e 
 */
function showTooltip(e) {
    var $current = $(e.currentTarget);
    var $parent = $current.parent('.tool-tip-wrap');
    var $tooltip = $current.next('.tool-tip');
    var margin_w = 14;
    var win_h = $window.innerWidth();
    var tooltip_l = $tooltip.offset().left;
    var tooltip_w = 0;
    var overflow_right = 0;
    if ($parent.hasClass('show')) {
        $parent.removeClass('show');
        $tooltip.css({left: ''});
    } else {
        $parent.addClass('show');
        tooltip_w = $tooltip.outerWidth();
        if(tooltip_l<margin_w) {
            $tooltip.offset({left: margin_w});
        } else {
            overflow_right = win_h - (tooltip_l + tooltip_w);
            if(overflow_right<0) {
                $tooltip.offset({left: tooltip_l + (win_h - (tooltip_l + tooltip_w)) - margin_w});
            }
        }
    }
    $('.tool-tip-icon').not($current).parent('.tool-tip-wrap').removeClass('show').children('.tool-tip').css({left: ''});
}




/**
 * table ページネーション
 * 初期化
 */
function initPaginationTable() {
    //console.group('initPaginationTable');
    $('[data-role="pagination-table"]').each(function (i, o) {
        var target_table_id = $(o).data('target');
        var current_page = $(o).data('currentPage');
        changePaginationTable(target_table_id, current_page);
    });
    //
    $('[data-role="pagination-nav"] a').off('click').on('click', function (e) {
        var $current = $(e.currentTarget);
        var change_page = $current.attr('href').replace('#', '');
        var target_table_id = $current.closest('[data-target]').data('target');
        if ($current.hasClass('current')) {
            return false;
        }
        changePaginationTable(target_table_id, change_page);
        return false;
    });
    //console.groupEnd('initPaginationTable');
}

/**
 * table ページネーション
 * 表示行の変更
 * @param {*} target_table_id 
 * @param {*} change_page 
 */
function changePaginationTable(target_table_id, change_page) {
    //console.group('changePaginationTable');
    var $target_table = $('[data-role="pagination-table"][data-target="' + target_table_id + '"]');
    var $target_nav = $('[data-role="pagination-nav"][data-target="' + target_table_id + '"]');
    var current_page = Number($target_table.data('currentPage'));
    var div_length = 10;   // 分割の数
    var target_tr_length = $target_table.find('tbody>tr').length; // 行数
    var max_page_length = Math.ceil(target_tr_length / div_length);    // ページネーションMAX
    //
    if (change_page === 'prev') {
        if (current_page > 1) {
            change_page = current_page - 1;
        } else {
            change_page = current_page;
        }
    } else if (change_page === 'next') {
        if (current_page < max_page_length) {
            change_page = current_page + 1;
        } else {
            change_page = current_page;
        }
    }
    $target_table.data('currentPage', change_page).attr('data-current-page', change_page);
    $target_nav.find('a').removeClass('current');
    $target_nav.find('a[href="#' + change_page + '"]').addClass('current');
    if (change_page <= 1) {
        $target_nav.find('a[href="#prev"]').addClass('current');
    } if (change_page >= max_page_length) {
        $target_nav.find('a[href="#next"]').addClass('current');
    }
    //
    $target_table.find('tbody>tr').each(function (i, o) {
        if (((i + 1) >= ((change_page * div_length) - div_length + 1)) && ((i + 1) <= (change_page * div_length))) {
            $(o).show();
        } else {
            $(o).hide();
        }
    });
    //console.groupEnd('changePaginationTable');
}



/**
 * table 1行ずつ表示
 * 初期化
 */
function initMoreTableRow() {
    //console.group('initMoreTableRow');
    $('[data-role="more-table-row"]').each(function (i, o) {
        var target_table_id = $(o).data('target');
        var current_page = $(o).data('currentPage');
        changeMoreTableRow(target_table_id, current_page);
    });
    //
    $('[data-role="more-table-row-btn"]').off('click').on('click', function (e) {
        var $current = $(e.currentTarget);
        var target_table_id = $current.data('target');
        var $target_table = $('[data-role="more-table-row"][data-target="' + target_table_id + '"]');
        var current_page = Number($target_table.data('currentPage'));
        var change_page = current_page + 1;
        changeMoreTableRow(target_table_id, change_page);
        return false;
    });
    //console.groupEnd('initMoreTableRow');
}

/**
 * table 1行ずつ表示
 * @param {*} target_table_id 
 * @param {*} change_page 
 */
function changeMoreTableRow(target_table_id, change_page) {
    //console.group('changeMoreTableRow');
    //console.log(target_table_id, change_page);
    var $target_table = $('[data-role="more-table-row"][data-target="' + target_table_id + '"]');
    var $target_btn = $('[data-role="more-table-row-btn"][data-target="' + target_table_id + '"]');
    var max_page_length = $target_table.find('tbody>tr').length;    // ページネーションMAX
    var $target_tr = $target_table.find('tbody>tr:lt(' + change_page + ')');
    //
    $target_table.data('currentPage', change_page).attr('data-current-page', change_page);
    //
    $target_tr.show();
    $target_table.find('tbody>tr').not($target_tr).hide();
    if (max_page_length === change_page) {
        $target_btn.prop('disabled', true);
    }
    //console.groupEnd('changeMoreTableRow');
}



/**
 * 別表 1つずつ表示
 * 初期化
 */
function initMoreOtherItem() {
    //console.group('initMoreOtherItem');
    $('[data-role="more-table-other"]').each(function (i, o) {
        $(o).find('[data-role="table-other-prev"],[data-role="table-other-next"]').hide();
        var target_table_id = $(o).data('target');
        var current_page = $(o).data('currentPage');
        changeMoreOtherItem(target_table_id, current_page);
    });
    //
    $('[data-role="more-table-other-btn"]').off('click').on('click', function (e) {
        var $current = $(e.currentTarget);
        var target_table_id = $current.data('target');
        var $target_table = $('[data-role="more-table-other"][data-target="' + target_table_id + '"]');
        var current_page = Number($target_table.data('currentPage'));
        var change_page = current_page + 1;
        changeMoreOtherItem(target_table_id, change_page);
        return false;
    });
    //console.groupEnd('initMoreOtherItem');
}

/**
 * 別表 1つずつ表示
 * @param {*} target_table_id 
 * @param {*} change_page 
 */
function changeMoreOtherItem(target_table_id, change_page) {
    //console.group('changeMoreOtherItem');
    //console.log(target_table_id, change_page);
    var $target_table = $('[data-role="more-table-other"][data-target="' + target_table_id + '"]');
    var $target_btn = $('[data-role="more-table-other-btn"][data-target="' + target_table_id + '"]');
    var max_page_length = $target_table.find('[data-role="more-table-other-item"]').length;    // ページネーションMAX
    var $target_tr = $target_table.find('[data-role="more-table-other-item"]:lt(' + change_page + ')');
    // 表を表示
    $target_table.data('currentPage', change_page).attr('data-current-page', change_page);
    $target_tr.show();
    $target_table.find('[data-role="more-table-other-item"]').not($target_tr).hide();
    if (max_page_length === change_page) {
        $target_btn.prop('disabled', true);
    }
    // 前へ、次へ表示
    $target_tr.find('[data-role="table-other-prev"]').show();
    if (change_page > 1) {
        $target_table.find('[data-role="more-table-other-item"]:eq(0)').find('[data-role="table-other-next"]').show();
        $target_table.find('[data-role="more-table-other-item"]:visible').find('[data-role="table-other-next"]').show();
        $target_table.find('[data-role="more-table-other-item"]:eq(' + (change_page - 1) + ')').find('[data-role="table-other-next"]').hide();
    }
    //
    //console.groupEnd('changeMoreOtherItem');
}



/**
 * 1件もチェックされていない時
 * @param {*} e 
 * @returns 
 */
function noChecked(e) {
    var $current = $(e.currentTarget);
    var target_table_id = $current.data('target');
    var $target_table = $('[data-role="check-limit-table"][data-target="' + target_table_id + '"]');
    $target_table.find('tbody input[type="checkbox"]');
    if ($target_table.find('tbody [type="checkbox"]:checked').length === 0) {
        alert('確認対象の帳票が選択されていません。\nチェックボックスは必ず１つ以上選択してください。');
        return false;
    }
}

/**
 * チェック数制限
 * @param {*} e 
 */
function checkLimit(e) {
    var $current = $(e.currentTarget);
    var $target_table = $current.closest('[data-role="check-limit-table"]');
    $target_table.find('tbody [type="checkbox"]:checked').length;
    if ($target_table.find('tbody [type="checkbox"]:checked').length >= 5) {
        $target_table.find('tbody [type="checkbox"]:not(:checked)').prop('disabled', true);
    } else {
        $target_table.find('tbody [type="checkbox"]:disabled').prop('disabled', false);
    }
}



/**
 * ナビ固定
 */
function resizeSubnav() {
    if ($sub_nav.hasClass('fixed')) {
        var win_height = $window.outerHeight();
        var win_scroll_top = $window.scrollTop();
        var header_h = $header.outerHeight();
        var sub_head_h = $('.pankuzu').height() + $('.body-head').outerHeight();
        var operation_h = ($operation.length > 0) ? $operation.outerHeight() : 0;
        var doc_height = $doc.outerHeight();
        var footer_height = $footer.outerHeight();
        var page_bottom = (doc_height - win_height);
        var sub_nav_style = {};
        // 上位置
        if (0 == win_scroll_top) {
            sub_nav_style.top = header_h + sub_head_h;
        } else if (0 < win_scroll_top && sub_head_h >= win_scroll_top) {
            sub_nav_style.top = header_h + sub_head_h - win_scroll_top;
        } else {
            sub_nav_style.top = header_h;
        }
        // 高さ
        if (0 <= win_scroll_top && sub_head_h >= win_scroll_top) {  // 上
            sub_nav_style.height = win_height - (header_h + sub_head_h + operation_h) + win_scroll_top;
        } else if ((page_bottom - footer_height) <= win_scroll_top) {   // 下
            sub_nav_style.height = win_height - (header_h + operation_h + footer_height);
        } else {    // 中間
            sub_nav_style.height = win_height - (header_h + operation_h);
        }
        $sub_nav.css(sub_nav_style);
    }
}


/**
 * （2022/4追記あり）
 */
var $expand = $('[data-role="expand"]');
var $sp_expand = $('[data-role="sp-expand"]');
$expand.on('click', showExpand);
$sp_expand.on('click', showExpand);
function showExpand(e) {
    //console.group('showExpand');
    var $current = $(e.currentTarget);
    var target_id = $current.data('expandTarget');
    var $target = $(target_id);
    //console.log($current, target_id, $target);
    if ($current.hasClass('show')) {
        $current.removeClass('show').addClass('hide');
        $target.slideUp('fast', function () {
            $target.removeClass('show').addClass('hide');
            $target.css({ 'display': '' });
        });

    } else {
        $current.removeClass('hide').addClass('show');
        $target.slideDown('fast', function () {
            $target.removeClass('hide').addClass('show');
            $target.css({ 'display': '' });
        });
    }
    //console.groupEnd('showExpand');
}


/**
 * タブ（2022/4追加）
 */
var $tab_switch = $('[data-role="tab-switch"]');
$tab_switch.on('click', showTabContents);
function showTabContents(e) {
  //console.log("click");
  var $current = $(e.currentTarget);
  var target_id = $current.data('switchTarget');
  var $target = $(target_id);
  var $current_tab = $current.parent();
  var $ul_tab = $current.parents('.tab');
  var $div_tab = $target.parents('.tab-area');
  //console.log($target);
  //console.log($ul_tab);
  //console.log($div_tab);
  if ($current_tab.hasClass('active')) {
      
  } else {
    $ul_tab.children('li').each(function() {
      $(this).removeClass('active');
    });
    $div_tab.children('div').each(function() {
      $(this).removeClass('show');
    });
    $current_tab.addClass('active');
    $target.addClass('show');
  }
}

/**
 * ロード時アンカーにジャンプ
 */
function jumpAnchorByLoad() {
    var hash = location.hash;
    if(hash){
      var header_h = $('.header').height();
      var $target = $(hash);
      var target_offset = $target.offset().top;
      $('html, body').scrollTop(0).animate({
        scrollTop: target_offset - header_h
      }, 400, 'swing');
    }
}



/**
 * 縦スクロールの有無でジャンプボタンの表示非表示
 */
function showPagejumpNav() {
    var $page_jump = $('#page_jump');
    if(!isSP()) {
        var win_height = $window.outerHeight();
        var doc_height = $doc.outerHeight();
        if (win_height < doc_height) {
            $page_jump.fadeIn('fast');
        } else {
            $page_jump.fadeOut('fast');
        }
    } else {
        if($page_jump.hasClass('sp-show')) {
            $page_jump.show();

        } else {
            $page_jump.hide();
        }
    }
}




/**
 * ジャンプするコンテンツの数で↑↓ボタンを表示非表示
 */
function setPagejumpNav() {
    var $target_li = $('#page_jump').find('.content_prev, .content_next');
    if($jump_content.length>1) {
        $target_li.show();
    } else {
        $target_li.hide();
    }
}